;*****************  ***********************
;  ATtiny25/45/85
;  8/4=2 
.NOLIST
.include "tn85def.inc"
.LIST
; 
; PB0   - GND  (pin 5)
; PB1   -  Up, Vref=1,1v (pin 6)
; PB2   - INT0 (pin 7)
; PB3   - GND  (pin 2)
; PB4   - OUT LED (pin 3)
; PB5   - RST  (pin 1)

;!!!!!!!!!!!!!!!!!!!!
;  tiny15 
; PB3   - OUT  LED (pin 3)
; PB4   - GND  (pin 2)
;!!!!!!!!!!!!!!!!!!!!

.equ  LED     =PB4 ; OUT

; 
.equ  Tdead  =$08  ; - .TMR1 (CK/4)   CK=8/4=2mhz 
; (1/2mhz)*256*4*$8=512*8=4096 mks -  

          .org  $0000

          rjmp  BEGIN
          rjmp  Inter0  ; . INT0
          nop           ;  
          nop           ; /
          nop           ; /
          nop           ; /
          nop           ; /
          nop           ; /
          nop           ; /
          nop           ; /
          nop           ; /
          nop           ; /
          nop           ; /
          nop           ; /
          nop           ; /
; 
BEGIN:    wdr               ;  WDT
          cli               ; .  .
          clr   R16
          out   MCUSR,R16   ;   RESET
          ldi   R17,$1E     ; 0001.1110
          ldi   R18,$0E     ; 0000.1110
          out   WDTCR,R17
          out   WDTCR,R18   ; . WDT  1 
          out   SPH,R16     ; 00
          ldi   R17,$DF     ; RAMEND tiny25
          out   SPL,R17     ; $00DF - 
          ldi   R17,$40     ; 0100.0000
          out   GIMSK,R17   ;  INT0
          ldi   R17,$60     ; 0110,0000
          out   GIFR,R17    ;  
          out   TIMSK,R16   ;  . 
          out   SPMCSR,R16  ;    FLASH
          ldi   R17,$43     ; 0100.0011
          out   MCUCR,R17   ; SLEEP - dis, IDL, . . _|
          out   GTCCR,R16   ; output compare disable
          out   TCCR0A,R16  ;  OC0A, OC0B
          out   TCCR0B,R16  ;  TMR0
          out   PLLCSR,R16  ;  PLL
          ldi   R17,$80     ; 1000.0000
          out   CLKPR,R17
          ldi   R17,$02     ; 0000.0010
          out   CLKPR,R17   ; system clk =8/4mhz
          out   DT1A,R16    ; Dead Time  
          out   DT1B,R16    ; /
          out   DTPS1,R16   ; /
          out   PRR,R16     ; Power Reduction  
          out   EECR,R16    ;  EEPROM
          out   PCMSK,R16   ; pin change disable
          ldi   R17,$02     ; 0000.0010
          out   DIDR0,R17   ; AIN1 (PB1) Digital Input Disable
          out   USICR,R16   ; USI disable
          ldi   R17,$50     ; 0101.0000
          out   ACSR,R17    ; PB1 = -, Vref = +1,1v
          out   ADMUX,R16   ; . ADC
          out   ADCSRA,R16  ; /
          out   ADCSRB,R16  ; PB1 (AIN1) comparator input
          ldi   R17,$03     ; 0000.0011
          out   TCCR1,R17   ; TMR1=CK/4=2/4mhz start
          out   PORTB,R16   ; PORTB=0
          ldi   R17,$10     ; 0001.0000
          out   DDRB,R17    ; PB4-OUT
          sbis  ACSR,ACO    ; Up - OK
          rjmp  PC-1        ;  Up
          out   TCNT1,R16   ;  TMR1
          ldi   R17,$04     ; 0000.0100
          out   TIFR,R17    ;  . TMR1
          ldi   R18,$FF     ; . . . .
          sei               ; . .
;  
CIKL:     in    R16,TIFR
          sbrs  R16,TOV1
          rjmp  CIKL        ;  . TMR1
          ldi   R16,$04     ; 0000.0100
          out   TIFR,R16    ;  . TMR1
          rjmp  PC+1
          wdr
          cpi   R18,$FF
          breq  CIKL
          inc   R18
          rjmp  CIKL        ;  .

;  INT0
; :  R18 - . - . TMR1 (. .)
; : R18 -  - . TMR1
;  R20,21
Inter0:   in    R21,SREG    ; 
          sbic  ACSR,ACO    ; Up > Umax
          sbi   PORTB,LED   ; Up < Umax, . LED
          clr   R20
          out   TCNT1,R20   ;  TMR1
          ldi   R20,$04     ; 0000.0100
          out   TIFR,R20    ;  . TMR1
          mov   R20,R18     ; . .
Inter1:   dec   R20         ; 1
;          rjmp  PC+1        ; 2
;          rjmp  PC+1        ; 2
;          rjmp  PC+1        ; 2
;          rjmp  PC+1        ; 2
          brne  Inter1      ; 2 R18*(3...11)/2=1,5...5,5mks
          cbi   PORTB,LED   ; . LED
          clr   R18
Inter2:   in    R20,TIFR
          sbrs  R20,TOV1
          rjmp  Inter2      ;  . TMR1
          ldi   R20,$04     ; 0000.0100
          out   TIFR,R20    ;  . TMR1
          rjmp  PC+1
          inc   R18
          cpi   R18,Tdead   ; R16-Tdead
          brcs  Inter2      ; R16 < Tdead, 
          ldi   R20,$60     ; 0110.0000
          out   GIFR,R20    ;    . 
          out   SREG,R21    ; 
          reti

